﻿using System.ComponentModel;

namespace ProjectSellPC.Entites
{
    public class Cheque
    {
        [System.ComponentModel.Browsable(false)]
        public int Id { get; set; }
        [DisplayName("Товары")]
        public List<ProductInCheque> Products { get; set; }
        [DisplayName("Клиент")]
        public Client Client { get; set; }

        [System.ComponentModel.Browsable(false)]
        public int ClientId { get; set; }
        [DisplayName("Дата покупки")]
        public DateTime PurchaseDate { get; set; }

        public static Cheque CreateEntity(int id, List<ProductInCheque> products, Client client, DateTime purchaseDate)
        {
            return new Cheque
            {
                Id = id,
                Products = products,
                Client = client,
                PurchaseDate = purchaseDate
            };
        }
    }
}
