﻿using ProjectSellPC.Entites.Enums;
using System.ComponentModel;

namespace ProjectSellPC.Entites
{
    public class Product
    {
        public int ID { get; private set; }
        [DisplayName("Имя")]
        public string Name { get; private set; }
        [DisplayName("Описание")]
        public string Description { get; private set; }
        [DisplayName("Цена")]
        public decimal Price { get; private set; }
        [DisplayName("Вид")]
        public ProductType ProductType { get; private set; }

        public static Product CreateEntity(int id, string name, string desc, decimal price, ProductType productType)
        {
            return new Product { ID = id,
                Name = name ?? string.Empty,
                Description = desc ?? string.Empty,
                Price = price,
                ProductType = productType };
        }
        public override string ToString()
        {
            return Name;
        }
    }
}
