using ProjectSellPC.Forms;
using ProjectSellPC.Forms.ProductsOnWarehouse;
using ProjectSellPC.Forms.Receipt;
using ProjectSellPC.Forms.Warehouse;
using ProjectSellPC.Forms.DocReports;
using Unity;

namespace ProjectSellPC
{
    public partial class ShopForm : Form
    {
        private readonly IUnityContainer _container;

        public ShopForm(IUnityContainer container)
        {
            InitializeComponent();

            _container = container ?? throw new ArgumentNullException(nameof(container));
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<ProductForm>().ShowDialog();
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<ClientForm>().ShowDialog();
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<WarehouseForm>().ShowDialog();

        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<ProductsOnWarehouseForm>().ShowDialog();

        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<ChequeForm>().ShowDialog();

        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<DocReportForm>().ShowDialog();
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<ExcelReportForm>().ShowDialog();
        }

        private void ShopForm_Load(object sender, EventArgs e)
        {

        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _container.Resolve<PdfReportForm>().ShowDialog();
        }
    }
}