﻿using ProjectSellPC.Repos;
using Unity;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectSellPC.Forms.ProductsOnWarehouse
{
    public partial class ProductsOnWarehouseForm : Form
    {
        private readonly IUnityContainer _container;
        private readonly IProductOnWarehouseRepository _productOnWarehouseRepository;

        public ProductsOnWarehouseForm(IUnityContainer unityContainer, IProductOnWarehouseRepository productOnWarehouseRepository)
        {
            InitializeComponent();

            _container = unityContainer ?? throw new ArgumentNullException(nameof(unityContainer));
            _productOnWarehouseRepository = productOnWarehouseRepository ?? throw new ArgumentNullException(nameof(productOnWarehouseRepository));
        }

        private void ProductsOnWarehouse_Load(object sender, EventArgs e)
        {
            try
            {
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при загрузке", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void LoadList() => productsDataGridView.DataSource = _productOnWarehouseRepository.ReadAll();

        private bool TryGetIdentifierFromSelectedRow(out int id)
        {
            id = 0;
            if (productsDataGridView.SelectedRows.Count < 1)
            {
                MessageBox.Show("Нет выбранной записи", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }

            id = Convert.ToInt32(productsDataGridView.SelectedRows[0].Cells["Id"].Value);
            return true;
        }

        private void addButton_Click(object sender, EventArgs e)
        {
            try
            {
                _container.Resolve<ProductsOnWarehouseSettingsForm>().ShowDialog();
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при добавлении", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void deleteButton_Click(object sender, EventArgs e)
        {
            if (!TryGetIdentifierFromSelectedRow(out var findId))
            {
                return;
            }
            if (MessageBox.Show("Удалить запись?", "Удаление", MessageBoxButtons.YesNo) != DialogResult.Yes)
            {
                return;
            }
            try
            {
                _productOnWarehouseRepository.Delete(findId);
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при изменении", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

    }
}
