﻿using ProjectSellPC.Entites.Enums;
using ProjectSellPC.Entites;
using ProjectSellPC.Repos;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ProjectSellPC.Repos;


namespace ProjectSellPC.Forms.Warehouse
{
    public partial class WarehouseSettingsForm : Form
    {
        private readonly IWarehouseRepository _repository;

        private int? _WarehouseID;

        public int Id
        {
            set
            {
                try
                {
                    var Warehouse = _repository.Read(value);
                    if (Warehouse == null)
                    {
                        throw new InvalidDataException(nameof(Warehouse));
                    }
                    adressTextbox.Text = Warehouse.Adress;
                    sizeNumeric.Value = Warehouse.Size;
                    _WarehouseID = value;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Ошибка при данных", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
        }

        public WarehouseSettingsForm(IWarehouseRepository repository)
        {
            InitializeComponent();
            _repository = repository ?? throw new ArgumentNullException(nameof(repository));

        }

        private void WarehouseFormSettings_Load(object sender, EventArgs e)
        {

        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrWhiteSpace(adressTextbox.Text))
                {
                    throw new Exception("Имеются незаполненные поля");
                }

                if (_WarehouseID.HasValue)
                {

                    _repository.Update(CreateWarehouse(_WarehouseID.Value));
                }
                else
                {

                    _repository.Create(CreateWarehouse(0));
                }

                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при сохранении",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private Entites.Warehouse CreateWarehouse(int id)
        {
            return Entites.Warehouse.CreateEntity(id, (int)sizeNumeric.Value, adressTextbox.Text);
        }
    }
}
